#include <atomic>
#include <cds/sync/spinlock.h>
#include <ctime>
#include <iostream>
#include <string>
#include <thread>

using namespace std;

int x;
atomic_int y;
cds::sync::spin_lock<cds::backoff::LockDefault> mutex;

void Thread() {
  for (int i = 0; i < 100000; i++) {
    for (int j = 0; j < 3000; j++) {
      //  for (int i = 0; i < 300000; i++) {
      //    for (int j = 0; j < 300000; j++) {
      if (!mutex.is_locked()) {
        mutex.lock();
        x = 1;
        y.load(memory_order_relaxed);
        mutex.unlock();
      }
    }
  }
}

int main() {
  const int kThreads = 6;
  cout << "Starting " << kThreads << " threads for Spinlock...\n";
  
  struct timespec start, finish;
  double elapsed = 0.0;
  clock_gettime(CLOCK_MONOTONIC, &start);

  std::thread threads[kThreads];
  for (int i = 0; i < kThreads; i++) {
    threads[i] = std::thread(Thread);
  }

  for (int i = 0; i < kThreads; i++) {
    threads[i].join();
  }
  clock_gettime(CLOCK_MONOTONIC, &finish);
  elapsed = (finish.tv_sec - start.tv_sec);
  elapsed += (finish.tv_nsec - start.tv_nsec) / 1000000000.0;
  cout << "All threads finished.\n";
  cout << "Time: " << elapsed << " seconds\n";

  return 0;
}
